from sensor.Sensor import Sensor
from utils.datatypes import *
from utils import i18n

import commands
import time


class ExternalInterval(Sensor):

    def __init__(self, cmd, name,interval = "1000"):

        self.__output = ""
        

        Sensor.__init__(self)
        self._set_config_type("update", TYPE_INT, int(interval))
        self._set_config_type("cmd", TYPE_STRING, name)
                
        self._add_timer(int(interval), self.__on_tick)
        self._add_thread(self.__command_thread, cmd)
        

        
    def get_configurator(self):

        configurator = self._new_configurator()
        configurator.set_name("External")
        configurator.add_title(self._get_config("cmd"))
        configurator.add_spin("Update every (ms):", "update",
                                "Updates the display(s) every x milliseconds",
                                50, 3600000)

        return configurator

    def __on_tick(self):

        data = self._new_output()
        if (self.__output): data.set("value", self.__output)
        self._send_output(data)

        return 1



    def __command_thread(self, cmd):

        while (1):
            if (self._is_stopped()): break
            
            fail, output = commands.getstatusoutput(cmd)
            if (fail): output = ""

            self.__output = output
            update = self._get_config("update")
            time.sleep(update*0.001)
            


def new_sensor(args): return apply(ExternalInterval, args)
