from sensor.Sensor import Sensor
from utils.datatypes import *
from utils import i18n

import commands
import time
import os
import profile

class MemoOver(Sensor):

	def __init__(self):
		
		global _; _ = i18n.Translator("MemoOver-sensor")
		
		self.__output = ""
		
		self.__develop = 0
		self.__notes = []
		self.__text = ""
		self.__showtext=0
		memo=[]
		self.__lastedit = ""
		
		Sensor.__init__(self)
		self._set_config_type("update", TYPE_INT, 1000)
		self._set_config_type("Memo", TYPE_STRING, "~/.gdesklets/memo2.py")
		self._set_config_type("monitor", TYPE_STRING, "")
		self._set_config_type("font", TYPE_STRING, "sans 10")
		self._set_config_type("fontcolor", TYPE_STRING, "black")
		self._set_config_type("Script", TYPE_BOOL, 0)
		
		filename = "~/.gdesklets/memo2.py"
		try :
			execfile( filename.replace("~", os.getenv("HOME") ) )
		except : 
			memo = [["Could not import data","Please verify that your memo file is correct python code",4,0]]
		self.__notes = memo
		
		self._add_thread(self.__command_thread)
		self._add_timer(1000, self.__on_tick,0)
		self._add_timer(10000, self.__on_tick,1)
		
	def get_configurator(self):
		configurator = self._new_configurator()
		configurator.set_name(_("Memo"))
		configurator.add_title(_("Memo configuration"))
		configurator.add_spin(_("Update every (ms):"), "update",
					_("Updates the display(s) every x milliseconds"),
					50, 3600000)
		configurator.add_entry(_("Memo file:"), "Memo",
					_("Memo script or file"))
		configurator.add_font_selector(_("Font :"),"font",
						_("Font used in the memo list"))
		configurator.add_color_selector(_("Font color :"),"fontcolor",
						_("Color used in the memo list"))
		configurator.add_checkbox(_("Script"), "Script",
					_("Check this if you want to use the gtodo script or any other file where we don't want to check if the target file has changed"))
		configurator.add_entry(_("File to monitor:"), "monitor",
					_("If Script is not checked, the file to monitor (none = memo file) (use '~/.gtodo/todos' with the gtodo script)"))
		
		return configurator

	def __on_tick(self,cont):
		data = self._new_output()
		
		span=""
		i=0
		
		font = self._get_config("font")
		color = self._get_config("fontcolor")
		
		for note in self.__notes:
			
			if (note[2]==1):
				span = ""
			elif (note[2]==2):
				span = "weight='bold'"	
			elif (note[2]==3):
				span = "weight='bold' foreground='blue'"
			elif (note[2]==4):
				span = "weight='bold' foreground='red'"
				
			if (note[3]==1):
				span += " strikethrough='true'"

			ti = "<span "+span +">" + note[0] +"</span>"
			data.set("titles[%i]" % i,ti  )	
			data.set("font[%i]" % i, font)
			data.set("color[%i]" % i, color)
			i+=1	
			
		data.set("array-len", i)
		data.set("showdetail", self.__showtext)
		data.set("detail", self.__text)
		self._send_output(data)

		return cont

	def call_action(self, action, path, args = []):
		if (action == "enter"):
			self.__showtext = 1
			self.__text = self.__notes[path[0]][1]
			self.__on_tick(0)
		elif (action == "leave"):
			self.__showtext = 0
			self.__on_tick(0)
			
			
	def __command_thread(self):
		while (1):
			if (self._is_stopped()): break
			
			filename = (self._get_config("Memo")).replace("~",os.getenv("HOME"))
			if self._get_config("monitor") == "":
				filetomonitor = filename
			else:
				filetomonitor = (self._get_config("monitor")).replace("~",os.getenv("HOME"))
				
			if ( ( self.__lastedit != os.path.getmtime(filetomonitor) ) or (self._get_config("Script")) ):
				self.__lastedit = os.path.getmtime(filetomonitor)
				
				global memo
				
				try :
					execfile( filename )
				except : 
					memo = [["Could not import data","Please verify that your memo file is correct python code",4,0]]
				
				self.__notes = memo
			
			
			update = self._get_config("update")
			time.sleep(update*0.001)
			
def new_sensor(args): return apply(MemoOver, args)
